package com.xiesx.fastboot;

import com.xiesx.fastboot.utils.RuntimeUtils;

import lombok.extern.slf4j.Slf4j;

@Slf4j
public class SpringStartup {

    public static String classUrl;

    /** 由于是分布式环境，该名字为每个tomcat的目录名（在部署时必须唯一） */
    public static String servername;

    public static String serverpath;

    public static void init() {
        classUrl = RuntimeUtils.getRootPath().toLowerCase();
        if (classUrl.contains("target")) {// 本地
            int index = classUrl.indexOf("/target");
            if (index > 0) {
                String path = classUrl.substring(0, index);
                index = path.lastIndexOf("/");
                servername = path.substring(index + 1);
                serverpath = classUrl.split(servername)[0] + servername;
            }
        } else if (classUrl.contains("web-inf")) {// tomcat启动
            int index = classUrl.indexOf("/web-inf");
            if (index > 0) {
                String path = classUrl.substring(0, index);
                index = path.lastIndexOf("/");
                servername = path.substring(index + 1);
                serverpath = classUrl.split(servername)[0] + servername;
            }
        } else if (classUrl.contains("webapps")) {// jar启动
            int index = classUrl.indexOf("/webapps");
            if (index > 0) {
                String path = classUrl.substring(0, index);
                index = path.lastIndexOf("/");
                servername = path.substring(index + 1);
                serverpath = classUrl.split(servername)[0] + servername;
            }
        } else {
            servername = "unknown";
            serverpath = classUrl;
        }
        log.info("Startup name: " + servername + ", path: " + serverpath);
    }
}
