package com.xiesx.fastboot.core.jpa.aop;

import com.xiesx.fastboot.core.jpa.annotation.TargetDataSource;
import com.xiesx.fastboot.core.jpa.cfg.DynamicRoutingDataSource;
import org.aspectj.lang.ProceedingJoinPoint;
import org.aspectj.lang.annotation.Around;
import org.aspectj.lang.annotation.Aspect;
import org.springframework.core.annotation.Order;
import org.springframework.stereotype.Component;

/**
 * @Remark: 切面拦截动态数据源注解
 * @Author: lsw
 * @Date : 2022/3/14 18:26
 */
@Order(0)
@Aspect
@Component
public class RoutingAopAspect {

    public RoutingAopAspect(){
        System.out.println("--------------------------RoutingAopAspect");
    }

    @Around("@annotation(targetDataSource)")
    public Object routingWithDataSource(ProceedingJoinPoint joinPoint, TargetDataSource targetDataSource) throws Throwable {
        try {
            DynamicRoutingDataSource.setRoutingDataSource(targetDataSource.value());
            return joinPoint.proceed();
        } finally {
            DynamicRoutingDataSource.removeRoutingDataSource();
        }
    }
}
