package com.xiesx.fastboot.utils;

import java.beans.PropertyDescriptor;
import java.util.Arrays;
import java.util.Iterator;
import java.util.Map;
import java.util.Set;

import org.apache.commons.lang3.ObjectUtils;
import org.springframework.beans.BeanWrapper;
import org.springframework.beans.BeanWrapperImpl;

import com.google.common.collect.Sets;

import lombok.NonNull;

public class CopyUtils {

    @Deprecated
    public static String[] ignoreNullNames(@NonNull Object source) {

        final BeanWrapper beanWrapper = new BeanWrapperImpl(source);

        PropertyDescriptor[] pds = beanWrapper.getPropertyDescriptors();

        Set<String> noValuePropertySet = Sets.newHashSet();
        Arrays.stream(pds).forEach(pd -> {
            Object propertyValue = beanWrapper.getPropertyValue(pd.getName());
            if (ObjectUtils.isEmpty(propertyValue)) {
                noValuePropertySet.add(pd.getName());
            } else {
                if (Iterable.class.isAssignableFrom(propertyValue.getClass())) {
                    Iterable<?> iterable = (Iterable<?>) propertyValue;
                    Iterator<?> iterator = iterable.iterator();
                    if (!iterator.hasNext()) {
                        noValuePropertySet.add(pd.getName());
                    }
                }
                if (Map.class.isAssignableFrom(propertyValue.getClass())) {
                    Map<?, ?> map = (Map<?, ?>) propertyValue;
                    if (map.isEmpty()) {
                        noValuePropertySet.add(pd.getName());
                    }
                }
            }
        });
        String[] result = new String[noValuePropertySet.size()];
        return noValuePropertySet.toArray(result);
    }

    public static String[] nullNames(@NonNull Object source){
        return ignoreNullNames(source);
    }

    public static String[] notNullNames(@NonNull Object source) {

        final BeanWrapper beanWrapper = new BeanWrapperImpl(source);

        PropertyDescriptor[] pds = beanWrapper.getPropertyDescriptors();

        Set<String> noValuePropertySet = Sets.newHashSet();
        Arrays.stream(pds).forEach(pd -> {
            Object propertyValue = beanWrapper.getPropertyValue(pd.getName());
            if (ObjectUtils.isNotEmpty(propertyValue)) {
                noValuePropertySet.add(pd.getName());
            }
        });
        String[] result = new String[noValuePropertySet.size()];
        return noValuePropertySet.toArray(result);
    }
}
